#include <stdlib.h>
#include <netinet/in.h>

typedef struct _spider_header {
  float nslice;        /* number of slices (planes) in volume (=1 for an image) */
  float nrow;          /* number of rows per slice. */
  float irec;          /* total number of records in the file (unused) */
  float nhistrec;      /* (obsolete, unused) */
  float iform;         /* file type specifier. */
  float imami;         /* maximum/minimum flag */
  float fmax;          /* maximum value */
  float fmin;          /* minimum value */
  float av;            /* average value */
  float sig;           /* standard deviation. -1.0 indicates that sig has not been computed */
  float ihist;         /* (obsolete, no longer used). */
  float nsam;          /* number of pixels per line. */
  float labrec;        /* number of records in file header (label). */
  float iangle;        /* flag that tilt angles are present. */
  float phi;           /* tilt angle (See note #2 below). */
  float theta;         /* tilt angle. */
  float gamma;         /* tilt angle (also called psi). */
  float xoff;          /* x translation. */
  float yoff;          /* y translation. */
  float zoff;          /* z translation. */
  float scale;         /* scale factor. */
  float labbyt;        /* total number of bytes in header. */
  float lenbyt;        /* record length in bytes. */
  float istack; 
  float inuse;
  float maxim; 
  float imgnum;
  float junk0;
  float junk1;
  float Kangle; /* flag that additional angles are present in header. 
		   1 = one additional rotation is present, 
		   2 = additional rotation that preceeds the rotation that was stored in words 15..20. */
  float phi1;
  float theta1;
  float psi1;
  float phi2;
  float theta2;
  float psi2;

  char junk2[700];

  char cdat[12];   /* character * 11 containing creation date e.g. 27-MAY-1999 */
  char ctim[8];    /* character * 8 containing creation time e.g. 09:43:19 */
  char ctit[160];  /* character * 160 containing title */  

} spider_header_t;

int spider_read(int fd, spider_header_t *header, float **buf, void *(*malloc)(size_t));
